/*
 *  TOPPERS/A-WDG
 *      Automotive Watchdog Driver
 *
 *  Copyright (C) 2014-2015 by Center for Embedded Computing Systems
 *                             Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2014-2015 by AISIN COMCRUISE Co., Ltd., JAPAN
 *  Copyright (C) 2014-2015 by FUJI SOFT INCORPORATED, JAPAN
 *  Copyright (C) 2014-2015 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2014-2015 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2014-2015 by SCSK Corporation, JAPAN
 *  Copyright (C) 2014-2015 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2014-2015 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2014-2015 by Witz Corporation
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: Wdg.c 1340 2015-04-22 01:20:50Z fsi-kaitori $
 */

/* Wdg.c */
#include "Wdg.h"
#include "Wdg_Target.h"
#include "Wdg_Cbk.h"
#include "SchM_Wdg.h"
#include "Det.h"
#include "Dem.h"	/* [WDG062][WDG080][WDG105] */
#include "MemMap.h"

/*
 *  ؿΥץȥ
 */
LOCAL_INLINE uint16 set_trigger_cnt(uint16 timeout, uint16 interrupt_period);

/*
 *  ߼¹Wdgե졼
 */
const Wdg_ConfigType *p_cur_wdg_config;

/*
 *  Wdgν
 */
#if WDG_DEV_ERROR_DETECT != FALSE
static uint8 wdg_state = WDG_UNINIT;
#endif /* WDG_DEV_ERROR_DETECT != FALSE */

/*
 *  [WDG106] Wdg_Init
 */
void
Wdg_Init(const Wdg_ConfigType *ConfigPtr)
{
	TRIGGER_CB			*p_trigger_cb;
	const WDG_MODE_INIB	*p_current_mode;

	SchM_Enter_Wdg_Reentrant();

	/* [WDG089] ConfigPtrNULL_PTRǤ */
	WDG_CHECK_PARAM((ConfigPtr != NULL_PTR), WdgServiceId_Init, WDG_E_PARAM_POINTER);

	/* [NWDG004] WdgΥ⥸塼֤WDG_BUSYξ */
	WDG_CHECK_PARAM((wdg_state != WDG_BUSY), WdgServiceId_Init, WDG_E_DRIVER_STATE);

	/* ߼¹Υե졼ݻ */
	p_cur_wdg_config = ConfigPtr;

	p_trigger_cb = p_cur_wdg_config->p_trigger_cb;
	p_trigger_cb->current_mode = p_cur_wdg_config->WdgDefaultMode;

	/* [WDG001] ϡɥ*/
	if (p_trigger_cb->current_mode != WDG_OFF_MODE) {
		p_current_mode = &(p_cur_wdg_config->p_mode_inib_table[p_trigger_cb->current_mode]);

		/* [NWDG006] p_current_modeNULL_PTRξ */
		WDG_CHECK_PARAM((p_current_mode != NULL_PTR), WdgServiceId_Init, WDG_E_PARAM_POINTER);

		/* ȥꥬ */
		p_trigger_cb->trigger_cnt = set_trigger_cnt(WDG_INIT_TIMEOUT, p_current_mode->interrupt_period);

		/* [WDG051][WDG101] ¸ */
		wdg_target_start(p_current_mode);
	}
	else {
		/* ȥꥬ */
		p_trigger_cb->trigger_cnt = 0U;

		/* ¸ */
		wdg_target_off_mode();
	}

	/* [WDG019][WDG100] ֤ */
	WDG_SET_STATE(WDG_IDLE);

  error_exit:
	SchM_Exit_Wdg_Reentrant();
	return;
}

/*
 *  [WDG107] Wdg_SetMode
 */
Std_ReturnType
Wdg_SetMode(Wdg_ModeType WdgMode)
{
	Std_ReturnType		ercd;
	uint16				timeout;
	TRIGGER_CB			*p_trigger_cb;
	const WDG_MODE_INIB	*p_pre_mode_inib;
	const WDG_MODE_INIB	*p_current_mode;

	/* [NWDG005] ¾ʤ */

	/* [WDG017][WDG035] WdgΥ⥸塼֤WDG_IDLEǤʤ */
	WDG_CHECK_INITIALIZED_ERCD(WdgServiceId_SetMode);

	/* [WDG091] WdgModeϰϳǤ */
	WDG_CHECK_PARAM_ERCD(WdgMode <= WDG_OFF_MODE, WdgServiceId_SetMode, WDG_E_PARAM_MODE);

	/* [NWDG007] ⡼ڤؤ̵Ǥ */
	WDG_CHECK_PARAM_ERCD(WDG_SET_MODE_VALID != FALSE, WdgServiceId_SetMode, WDG_E_PARAM_MODE);

#if WDG_DISABLE_ALLOWED == FALSE
	/* [WDG026] WdgModeWDG_OFF_MODEǤ */
	WDG_CHECK_DEM_EXIT_ERCD(WdgMode != WDG_OFF_MODE, WDG_DEM_DISABLE_REJECTED);
#endif /* WDG_DISABLE_ALLOWED == FALSE */

	/* [WDG018][WDG052] WdgΥ⥸塼֤WDG_BUSYꤹ */
	WDG_SET_STATE(WDG_BUSY);

	p_trigger_cb = p_cur_wdg_config->p_trigger_cb;

	if (p_trigger_cb->current_mode != WdgMode) {
		p_pre_mode_inib = &(p_cur_wdg_config->p_mode_inib_table[p_trigger_cb->current_mode]);

		/* [NWDG006] p_pre_mode_inibNULL_PTRξ */
		WDG_CHECK_PARAM_ERCD((p_pre_mode_inib != NULL_PTR), WdgServiceId_SetMode, WDG_E_PARAM_POINTER);

		/* [WDG160] ߤΥ⡼ɹ */
		p_trigger_cb->current_mode = WdgMode;

		if (p_trigger_cb->current_mode != WDG_OFF_MODE) {
			p_current_mode = &(p_cur_wdg_config->p_mode_inib_table[p_trigger_cb->current_mode]);

			/* [NWDG006] p_current_modeNULL_PTRξ */
			WDG_CHECK_PARAM_ERCD((p_current_mode != NULL_PTR), WdgServiceId_SetMode, WDG_E_PARAM_POINTER);

			/* [WDG145] ߼ۤʤȥꥬ */
			if (p_pre_mode_inib->interrupt_period != p_current_mode->interrupt_period) {
				timeout = wdg_target_reset_timeout(p_trigger_cb->trigger_cnt, p_pre_mode_inib->interrupt_period);
				p_trigger_cb->trigger_cnt = set_trigger_cnt(timeout, p_current_mode->interrupt_period);
			}

			/* ¸⡼ */
			wdg_target_set_mode(p_current_mode);
		}
		else {
			/* ȥꥬ */
			p_trigger_cb->trigger_cnt = 0U;

			/* ¸ */
			wdg_target_off_mode();
		}
	}

	/* [WDG018] WdgΥ⥸塼֤WDG_IDLEꤹ */
	WDG_SET_STATE(WDG_IDLE);

	/* [WDG103] ⡼ؤ */
	ercd = E_OK;

  error_exit:
	/* [WDG016] ⡼ڴԤ */
	WDG_CHECK_DEM_ERCD(ercd != E_NOT_OK, WDG_DEM_MODE_FAILED);

	return(ercd);
}

/*
 *  [WDG155] Wdg_SetTriggerCondition
 */
void
Wdg_SetTriggerCondition(uint16 timeout)
{
	TRIGGER_CB			*p_trigger_cb;
	const WDG_MODE_INIB	*p_current_mode;

	/* [NWDG005] ¾ʤ */

	/* [WDG146] timeoutϰϳǤ */
	WDG_CHECK_PARAM(timeout <= WDG_MAX_TIMEOUT, WdgServiceId_SetTriggerCondition, WDG_E_PARAM_TIMEOUT);

	/* WdgΥ⥸塼֤WDG_BUSYꤹ */
	WDG_SET_STATE(WDG_BUSY);

	p_trigger_cb = p_cur_wdg_config->p_trigger_cb;
	p_current_mode = &(p_cur_wdg_config->p_mode_inib_table[p_trigger_cb->current_mode]);

	/* [NWDG006] p_current_modeNULL_PTRξ */
	WDG_CHECK_PARAM((p_current_mode != NULL_PTR), WdgServiceId_Init, WDG_E_PARAM_POINTER);

	/* [WDG136] ȥꥬ */
	p_trigger_cb->trigger_cnt = set_trigger_cnt(timeout, p_current_mode->interrupt_period);

	/* WdgΥ⥸塼֤WDG_IDLEꤹ */
	WDG_SET_STATE(WDG_IDLE);

  error_exit:
	return;
}

/*
 *  [WDG109][WDG099] Wdg_GetVersionInfo
 */
/* [WDG068] WDG_VERSION_INFO_API */
#if WDG_VERSION_INFO_API != FALSE
void
Wdg_GetVersionInfo(Std_VersionInfoType *versioninfo)
{
	/* [WDG174] versioninfoNULL_PTRǤ */
	WDG_CHECK_PARAM(versioninfo != NULL_PTR, WdgServiceId_GetVersionInfo, WDG_E_PARAM_POINTER);

	/* [WDG067]С */
	versioninfo->vendorID = WDG_VENDOR_ID;
	versioninfo->moduleID = WDG_MODULE_ID;
	versioninfo->sw_major_version = WDG_SW_MAJOR_VERSION;
	versioninfo->sw_minor_version = WDG_SW_MINOR_VERSION;
	versioninfo->sw_patch_version = WDG_SW_PATCH_VERSION;

  error_exit:
	return;
}
#endif /* WDG_VERSION_INFO_API != FALSE */

/*
 *  ȥꥬ
 */
LOCAL_INLINE uint16
set_trigger_cnt(uint16 timeout, uint16 interrupt_period)
{
	uint16 ret_trigger_cnt;

	/* [WDG140] Υॢͤ0ξ */
	if (timeout == 0U) {
		ret_trigger_cnt = 0U;
	}
	/* [WDG138][WDG139][DWDG001] ȥꥬ */
	else {
		ret_trigger_cnt = ((timeout + interrupt_period - 1) / interrupt_period) + 1U;
	}

	return(ret_trigger_cnt);
}

/*
 *  ʲ̤ݡȵǽ
 */

/* <WDG163> */
void
Wdg_Cbk_GptNotification(void)
{
	return;
}
