/*
 *  TOPPERS/A-WDG
 *      Automotive Watchdog Driver
 *
 *  Copyright (C) 2014-2015 by Center for Embedded Computing Systems
 *                             Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2014-2015 by AISIN COMCRUISE Co., Ltd., JAPAN
 *  Copyright (C) 2014-2015 by FUJI SOFT INCORPORATED, JAPAN
 *  Copyright (C) 2014-2015 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2014-2015 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2014-2015 by SCSK Corporation, JAPAN
 *  Copyright (C) 2014-2015 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2014-2015 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2014-2015 by Witz Corporation
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: Wdg_Target.h 1340 2015-04-22 01:20:50Z fsi-kaitori $
 */

#ifndef WDG_TARGET_H
#define WDG_TARGET_H

#include "SchM_Wdg.h"
#include "prc_sil.h"
#include "Std_Types.h"
#include "Wdg.h"
#include "target_hw_counter.h"

/* ȥꥬå */
#define TRIGGER_TIMER_CLOCK		(uint32) 8000U

/* åɥåå(Hz) */
#define WDTATCKI				1875U

/* åɥåޤΥ١ɥ쥹 */
#define WDGT_BASE				0xFFED0000U

/* åɥåޥȥꥬֹ */
#define WDGT_TRIGGER_IRQ		TAUFJ0I2_INTNO

/* åɥåޥȥꥬΥ١˥å */
#define WDGT_TRIGGER_U			0U

/* åɥåޥȥꥬΥ١ͥ */
#define WDGT_TRIGGER_CH			2U

#define WDTA_WDTE				0x00U
#define WDTA_MD					0x0CU

/* ӥå */
#define WDTA_RUN				0xACU

#define WDTA_OVF_9P				0x00U
#define WDTA_OVF_10P			0x10U
#define WDTA_OVF_11P			0x20U
#define WDTA_OVF_12P			0x30U
#define WDTA_OVF_13P			0x40U
#define WDTA_OVF_14P			0x50U
#define WDTA_OVF_15P			0x60U
#define WDTA_OVF_16P			0x70U

#define WDTA_ERM_NMI			0x00U
#define WDTA_ERM_RESET			0x04U

#define WDTA_WS_25				0x00U
#define WDTA_WS_50				0x01U
#define WDTA_WS_75				0x02U
#define WDTA_WS_100				0x03U

/* ¸ */
/* ɥץ(%) */
#define WINDOW_OPEN_25			25U
#define WINDOW_OPEN_50			50U
#define WINDOW_OPEN_75			75U
#define WINDOW_OPEN_100			100U

/* HWॢȻ(ms) */
#define HW_TIMEOUT_273			273U
#define HW_TIMEOUT_546			546U
#define HW_TIMEOUT_1092			1092U
#define HW_TIMEOUT_2184			2184U
#define HW_TIMEOUT_4369			4369U
#define HW_TIMEOUT_8738			8738U
#define HW_TIMEOUT_17476		17476U
#define HW_TIMEOUT_34952		34952U

/* ؿץȥ */
LOCAL_INLINE void wdg_trigger_init(uint16 wdg_interrupt_period);
LOCAL_INLINE void wdg_timer_init(const WDG_MODE_INIB *p_current_mode);
LOCAL_INLINE void wdg_trigger_int_clear(void);
LOCAL_INLINE void wdg_timer_trigger(const WDG_MODE_INIB *p_current_mode);
LOCAL_INLINE void wdg_target_start(const WDG_MODE_INIB *p_current_mode);
LOCAL_INLINE void wdg_target_off_mode(void);
LOCAL_INLINE void wdg_target_set_mode(const WDG_MODE_INIB *p_current_mode);
LOCAL_INLINE uint16 wdg_target_reset_timeout(uint16 trigger_cnt, uint16 pre_interrupt_period);

/*
 *  åɥåޥȥꥬߤν
 */
LOCAL_INLINE void
wdg_trigger_init(uint16 wdg_interrupt_period)
{
	/*  */
	SetTimerStopTAUJ(WDGT_TRIGGER_U, WDGT_TRIGGER_CH);

	/* ׵᥯ꥢ */
	HwcounterClearInterrupt(TAUJ_INTNO(WDGT_TRIGGER_U, WDGT_TRIGGER_CH));

	/* ߵ */
	HwcounterEnableInterrupt(TAUJ_INTNO(WDGT_TRIGGER_U, WDGT_TRIGGER_CH));

	/* 󥿡Х륿 */
	sil_wrh_mem((void *) TAUJCMOR(WDGT_TRIGGER_U, WDGT_TRIGGER_CH), MCU_TAUJ00_CMOR);
	sil_wrb_mem((void *) TAUJCMUR(WDGT_TRIGGER_U, WDGT_TRIGGER_CH), MCU_TAUJ00_CMUR);

	/* ޥȼ */
	sil_wrw_mem((void *) TAUJCDR(WDGT_TRIGGER_U, WDGT_TRIGGER_CH), (wdg_interrupt_period * TRIGGER_TIMER_CLOCK));

	/* ư */
	SetTimerStartTAUJ(WDGT_TRIGGER_U, WDGT_TRIGGER_CH);

	return;
}

/*
 *  [WDG161] åɥå޽
 */
LOCAL_INLINE void
wdg_timer_init(const WDG_MODE_INIB *p_current_mode)
{
	uint8	wdta_ovf;
	uint8	wdta_md = 0U;

	/* wdta_ovfꥻåͻ */
	wdta_ovf = sil_reb_mem((void *) (WDGT_BASE + WDTA_MD));
	wdta_ovf &= 0x70U;

	/* ॢȻư */
	switch (p_current_mode->WdgTimeoutReaction) {
	case WDG_RESET:
		wdta_md |= WDTA_ERM_RESET;
		break;
	case WDG_NMI:
		wdta_md |= WDTA_ERM_NMI;
		break;
	default:
		wdta_md |= WDTA_ERM_RESET;
		break;
	}

	/* ɥץ */
	switch (p_current_mode->WdgWindowOpenRate) {
	case WINDOW_OPEN_100:
		wdta_md |= WDTA_WS_100;
		break;
	case WINDOW_OPEN_75:
		wdta_md |= WDTA_WS_75;
		break;
	case WINDOW_OPEN_50:
		wdta_md |= WDTA_WS_50;
		break;
	case WINDOW_OPEN_25:
		wdta_md |= WDTA_WS_25;
		break;
	default:
		wdta_md |= WDTA_WS_100;
		break;
	}

	/* Хե󥿡Х */
	switch (p_current_mode->timeout) {
	case HW_TIMEOUT_34952:
		wdta_md |= WDTA_OVF_16P;
		break;
	case HW_TIMEOUT_17476:
		wdta_md |= WDTA_OVF_15P;
		break;
	case HW_TIMEOUT_8738:
		wdta_md |= WDTA_OVF_14P;
		break;
	case HW_TIMEOUT_4369:
		wdta_md |= WDTA_OVF_13P;
		break;
	case HW_TIMEOUT_2184:
		wdta_md |= WDTA_OVF_12P;
		break;
	case HW_TIMEOUT_1092:
		wdta_md |= WDTA_OVF_11P;
		break;
	case HW_TIMEOUT_546:
		wdta_md |= WDTA_OVF_10P;
		break;
	case HW_TIMEOUT_273:
		wdta_md |= WDTA_OVF_9P;
		break;
	default:
		wdta_md |= wdta_ovf;
		break;
	}

	sil_wrb_mem((void *) (WDGT_BASE + WDTA_MD), wdta_md);

	return;
}

/*
 *  åɥåޥȥꥬ׵᥯ꥢ
 */
LOCAL_INLINE void
wdg_trigger_int_clear(void)
{
	/* ׵᥯ꥢ */
	HwcounterClearInterrupt(TAUJ_INTNO(WDGT_TRIGGER_U, WDGT_TRIGGER_CH));

	return;
}

/*
 *  [WDG161] åɥåޥȥꥬ
 */
LOCAL_INLINE void
wdg_timer_trigger(const WDG_MODE_INIB *p_current_mode)
{
	/* ޥȥꥬ */
	sil_wrb_mem((void *) (WDGT_BASE + WDTA_WDTE), WDTA_RUN);

	return;
}

/*
 *  åɥå¸
 */
LOCAL_INLINE void
wdg_target_start(const WDG_MODE_INIB *p_current_mode)
{
	/* ޳ */
	wdg_timer_init(p_current_mode);

	/* ޥȥꥬ */
	sil_wrb_mem((void *) (WDGT_BASE + WDTA_WDTE), WDTA_RUN);

	/* ޥȥꥬ߳ */
	wdg_trigger_init(p_current_mode->interrupt_period);

	return;
}

/*
 *  åɥå¸off⡼
 */
LOCAL_INLINE void
wdg_target_off_mode(void)
{
	return;
}

/*
 *  åɥå¸⡼(ܥޥ̤б)
 */
LOCAL_INLINE void
wdg_target_set_mode(const WDG_MODE_INIB *p_current_mode)
{
	return;
}

/*
 *  ॢȺ(ܥޥ̤б)
 */
LOCAL_INLINE uint16
wdg_target_reset_timeout(uint16 trigger_cnt, uint16 pre_interrupt_period)
{
	uint16 timeout = 0U;

	return(timeout);
}

/*
 *  ̤ݡ
 *  - ƥ١󥳡
 *    <WDG093><WDG094><WDG095>
 *  - ȥꥬ(ꥢɥ쥹)
 *    <WDG034>
 *  - 󥨥ꥢ(ROM or RAM)
 *    <WDG168>
 *  - ¸ȤʬΥΤ
 *    <WDG031>
 */

#endif /* WDG_TARGET_H */
