/*
 *  TOPPERS/A-WDG
 *      Automotive Watchdog Driver
 *
 *  Copyright (C) 2014-2015 by Center for Embedded Computing Systems
 *                             Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2014-2015 by AISIN COMCRUISE Co., Ltd., JAPAN
 *  Copyright (C) 2014-2015 by FUJI SOFT INCORPORATED, JAPAN
 *  Copyright (C) 2014-2015 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2014-2015 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2014-2015 by SCSK Corporation, JAPAN
 *  Copyright (C) 2014-2015 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2014-2015 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2014-2015 by Witz Corporation
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: os.c 1340 2015-04-22 01:20:50Z fsi-kaitori $
 */

#include "Os.h"
#include "sysmod/serial.h"
#include "sysmod/syslog.h"
#include "sysmod/banner.h"
#include "target_serial.h"
#include "prc_sil.h"
#include "Wdg.h"
#include "Wdg_PBcfg.h"

/* INTP4 */
#define FCLA0CTL4_INTPL	0xFFC34030U
#define INTP4_NO		35U

/* INTP5 */
#define FCLA0CTL5_INTPL	0xFFC34034U
#define INTP5_NO		36U

void target_init(void);

TASK(MainTask)
{
	target_init();

	syslog(LOG_NOTICE, "=== Wdg_Init ===");
	Wdg_Init(&wdg_config_WdgSettingsConfig_0);

	while (1) {
	}

	ShutdownOS(E_OK);
}

/*
 *  SW_INTB
 */
ISR(C2ISR_FOR_SW_INTB)
{
	uint32			u32_address;
	volatile uint32	i;

	/* 쥸 */
	u32_address = EIC_ADDRESS(INTP5_NO);

	/* ׵ӥåȤΥꥢ */
	sil_wrh_mem((void *) u32_address, sil_reh_mem((void *) u32_address) & ~EIRFn);

	/* LED3 */
	fl850_led_output(0x40U);

	syslog(LOG_NOTICE, "[SW_INTB] CALL:Wdg_SetTriggerCondition(10000U)");
	/* ȥꥬǥ */
	Wdg_SetTriggerCondition(10000U);

	/*  */
	for (i = 0U; i < 10000U; i++) {
	}

	/* LED */
	fl850_led_output(0x00U);
}

/*
 *  SW_INTC
 */
ISR(C2ISR_FOR_SW_INTC)
{
	uint32 u32_address;

	/* 쥸 */
	u32_address = EIC_ADDRESS(INTP4_NO);

	/* ׵ӥåȤΥꥢ */
	sil_wrh_mem((void *) u32_address, sil_reh_mem((void *) u32_address) & ~EIRFn);

	syslog(LOG_NOTICE, "[SW_INTC] CALL:Wdg_SetTriggerCondition(0U)");
	/* ȥꥬǥ󥯥ꥢ */
	Wdg_SetTriggerCondition(0U);

	/* LED4 */
	fl850_led_output(0x80U);
}

ProtectionReturnType
ProtectionHook(StatusType FatalError)
{
	syslog(LOG_NOTICE, "## ProtectionHook is called !! (%d)", FatalError);

	return(PRO_SHUTDOWN);
}

void
StartupHook(void)
{
	syslog_initialize();
	syslog_msk_log(LOG_UPTO(LOG_INFO));
	InitSerial();
	print_banner();
}

sint32
main(void)
{
	StartOS(MainApp);
	while (1) ;
	return(0);
}

/* åȽ */
void
target_init(void)
{
	uint8	u8_reg;
	uint16	u16_reg;
	uint32	u32_address;
	uint32	u32_reg;

	/* INTP4ͭ */
	u8_reg = sil_reb_mem((void *) (FCLA0CTL4_INTPL));

	sil_wrb_mem((void *) (FCLA0CTL4_INTPL), (u8_reg | 0x01U));

	u16_reg = sil_reh_mem((void *) PM(8U));
	sil_wrh_mem((void *) PM(8U), (u16_reg | 0x0001U));

	u16_reg = sil_reh_mem((void *) PFC(8U));
	sil_wrh_mem((void *) PFC(8U), (u16_reg & ~0x0001U));

	u16_reg = sil_reh_mem((void *) PFCE(8U));
	sil_wrh_mem((void *) PFCE(8), (u16_reg | 0x0001U));

	u16_reg = sil_reh_mem((void *) PFCAE(8U));
	sil_wrh_mem((void *) PFCAE(8U), (u16_reg & ~0x0001U));

	u16_reg = sil_reh_mem((void *) PMC(8U));
	sil_wrh_mem((void *) PMC(8U), (u16_reg | 0x0001U));

	u32_address = EIC_ADDRESS(INTP4_NO);
	u32_reg = sil_reh_mem((void *) u32_address);
	sil_wrh_mem((void *) u32_address, (u32_reg & ~EIRFn));
	sil_wrh_mem((void *) u32_address, (u32_reg & ~EIMKn));

	/* INTP5ͭ */
	u8_reg = sil_reb_mem((void *) (FCLA0CTL5_INTPL));

	sil_wrb_mem((void *) (FCLA0CTL5_INTPL), (u8_reg | 0x01U));

	u16_reg = sil_reh_mem((void *) PM(11U));
	sil_wrh_mem((void *) PM(11U), (u16_reg | 0x0080U));

	u16_reg = sil_reh_mem((void *) PFC(11U));
	sil_wrh_mem((void *) PFC(11U), (u16_reg & ~0x0080U));

	u16_reg = sil_reh_mem((void *) PFCE(11U));
	sil_wrh_mem((void *) PFCE(11U), (u16_reg & ~0x0080U));

	u16_reg = sil_reh_mem((void *) PFCAE(11U));
	sil_wrh_mem((void *) PFCAE(11U), (u16_reg & ~0x0080U));

	u16_reg = sil_reh_mem((void *) PMC(11U));
	sil_wrh_mem((void *) PMC(11U), (u16_reg | 0x0080U));

	u32_address = EIC_ADDRESS(INTP5_NO);
	u32_reg = sil_reh_mem((void *) u32_address);
	sil_wrh_mem((void *) u32_address, (u32_reg & ~EIRFn));
	sil_wrh_mem((void *) u32_address, (u32_reg & ~EIMKn));
}
